
#include <stdlib.h>
#include <unistd.h>
#include <new>
#include "memoryUsed.h"

using namespace std;

inline void*
max(void* p1,void* p2)
{
    return (p1 < p2) ? p2 : p1;
}


size_t MemoryUsed::heapEnd;

// Global new
void* operator new(size_t size)
{
	void* p;
	p = malloc(size);
	if (!p) {
	    bad_alloc ba;
		throw ba;
	}
	size_t end = reinterpret_cast<size_t>(max(static_cast<char*>(p) + size,sbrk(0)));
	if (end > MemoryUsed::heapEnd) {
		MemoryUsed::heapEnd = end;
	}
	return p;
}

void* operator new[](size_t size)
{
	return operator new(size);
}

//Global delete
void operator delete(void* p)
{
	free(p);
}

void operator delete[](void* p)
{
	operator delete(p);
}


void 
MemoryUsed::report(const char* name)
{
	size_t growth = heapEnd - start_memory_usage;
	cout << "Memory Used " << name << " = " 
	     << growth
		 << "/" << heapEnd << endl;
}
