//***************************************************************************
//                        random.h  -  Create random data.
//                           -------------------
//  begin                : Thu Jun 3 2004
//  copyright            : (C) 2004 by Stan Benedict
//  email                : stanb@cybrquest.com
//**************************************************************************


#ifndef RANDOM_H
#define RANDOM_H


#include <stdlib.h>

class Random {
public:
	// Initialize random numbers with a seed value
	static void seed(uint v) { srandom(v); }
  	// return a random fraction value between 0.0 and 1.0
	static double fraction() {
		double value = random() * 1.0;
		return value/RAND_MAX;
	}
	// return a random 64 bit singed integer
	static int64 integer64() {
		int64 upper = random();
		upper = upper << 32;
		int64 lower = random();
		return  (upper + lower) * (-1 * (random() & 1));
	}
	// return a random 64 bit unsigned integer
	static uint64 uinteger64() {
		uint64 upper = random();
		upper = upper << 32;
		return random();
	}
	// return a random 32 bit singed integer
	static int32 integer32() { return random() * (-1 * (random() & 1)); }
	// return a random 32 bit integer value between 0 and RAND_MAX
	static uint32 uinteger32() { return random(); }
};

#endif
