//***************************************************************************
//                        types.h  -  description
//                           -------------------
//  begin                : Thu Jun 3 2004
//  copyright            : (C) 2004 by Stan Benedict
//  email                : stanb@cybrquest.com
//**************************************************************************


#ifndef TYPES_H
#define TYPES_H

#ifndef  __STDC_CONSTANT_MACROS
#define  __STDC_CONSTANT_MACROS 1
#endif

#include <stdint.h>

typedef uint64_t uint64;
typedef uint32_t uint32;
typedef uint16_t uint16;
typedef uint8_t uint8;
typedef int64_t int64;
typedef int32_t int32;
typedef int16_t int16;
typedef int8_t int8;

// Return size of an object or type in bits.
#define bitSizeof(v) (sizeof(v) * 8)
//=================================================================
// Use these defines to compute ranges for bitfields (int or uint)
// numbits must be > 0 to get a correct answer.
#define maxSignedValue(numBits)  (static_cast<int>((1U << ((numBits) - 1)) - 1))
#define minSignedValue(numBits)  (-maxSignedValue(numBits) - 1)
#define maxUnsignedValue(numBits) ((1U << ((numBits) - 1)) + ((1U << ((numBits) - 1)) - 1))

//===================================================================
// Use this to compute ranges for all possible integer sizes
#define maxSignedValue64(numBits) (static_cast<int64>((UINT64_C(1) << ((numBits) - 1)) - 1))
#define minSignedValue64(numBits) (-maxSignedValue64(numBits) - 1)
#define maxUnsignedValue64(numBits) \
	((UINT64_C(1) << ((numBits) - 1)) + ((UINT64_C(1) << ((numBits) - 1)) - 1))


#endif
