//===========================================================================
//  gshapeblock.h  -  manage a block of geometric shapes
//  -----------------------------------------------
//  begin                : Thu Jun 3 2004
//  copyright            : (C) 2004 by Stan Benedict
//  email                : stanb@cybrquest.com
//===========================================================================

#ifndef GSHAPEBLOCK_H
#define GSHAPEBLOCK_H

#include <typeinfo>
#include <vector>
#include "types.h"
#include "shape.h"
#include "gsort.h"

using namespace std;

#define shapeBlockTemplate template <typename baseType, typename coordinate_T, \
								typename geom_T>
#define shapeBlockTmpltArgs	baseType,coordinate_T,geom_T

shapeBlockTemplate
class varShapeBlock {
public:
	varShapeBlock(): _sorted(true),_numShapes(0) {}
	
	//====================================================================
	// Accessors
	//====================================================================

	// return geometry located at an offset location in block
	geom_T* geom(int offset) { return static_cast<geom_T*>(&_block[offset]); }
	
	// number of shape records stored in the block
	int numShapes() { return _numShapes; }

	//====================================================================
	// Manipulators
	//====================================================================
	
	// Sort the geom objects on lowerleft coordinate
	void sort();
	// Allocate space in the block for a varGeom. reclen is space in bytes.
	void* allocate(int reclen);
	
private:
	vector<baseType>	_block;
	int					_numShapes;
	bool				_sorted;
};

#endif

