//==============================================================================
//      gsort.cc  -  sort goemetric objects
//                           -------------------
//  begin                : |DATE|
//  copyright            : (C) |YEAR| by |AUTHOR|
//  email                : |EMAIL|
//==============================================================================

#include <new>
#include "gsort.h"

template<typename coordinate_T>
inline void 
splitInfo(const Box& logical, coordinate_T& xDim, coordinate_T& yDim,
				coordinate_T& maxDim, bool& splitX)
{
	xDim = logical.xDimension();
	yDim = logical.yDimension();
	if (xDim > yDim) {
		splitX = true;
		maxDim = xDim;
	} else {
		splitY = false;
		maxDim = yDim;
	}
} 

gsortTemplate
void*
gsortTreeNode<gsortTmpltArgs>::allocate(gsortTreeNode<gsortTmpltArgs>** parentPtr,
		const Box& logical,const Box& bbox,int reclen)
{
	coordinate_T xDim;
	coordinate_T yDim;
	coordinate_T maxDim;
	bool splitX;
	if (!isFull()) {
		return _shapes.allocate(bbox,reclen);
	}
	if (splitInX()) {
		coordinate_T xSplit = (logical.lowerLeft().x() + logical.upperRight().x())/2;
		if (bbox.lowerLeft().x() >= xSplit()) {
			Box& newLogical = logical;
			newLogical.lowerLeft().x(xSplit);
			if (!grtr()) {
				splitInfo(newLogical,xDim.yDim,maxDim,splitX);
			    _grtr = new gsortTreeNode(xDim > yDim,
					maxDim < maxSingedValue(bitSizeof(coordinate_T)/2));	
			}
			return grtr()->allocate(newLogical,bbox,recLen);
		} else if (bbox.upperRight.x() <= xSplit()) {
			Box& newLogical = logical;
			newLogical.upperRight().x(xSplit);
			if (!less()) {
				splitInfo(newLogical,xDim.yDim,maxDim,splitX);
			    _less = new gsortTreeNode(xDim > yDim,
					maxDim < maxSingedValue(bitSizeof(coordinate_T)/2));	
			}
			return less()->allocate(&_less,newLogical,bbox,recLen);
		}
	} else {
		coordinate_T ySplit = (logical.lowerLeft().y() + logical.upperRight().y())/2;
		if (bbox.lowerLeft().y() >= ySplit()) {
			Box& newLogical = logical;
			newLogical.lowerLeft().y(ySplit);
			if (!grtr()) {
				splitInfo(newLogical,xDim.yDim,maxDim,splitX);
			    _grtr = new gsortTreeNode(xDim > yDim,
					maxDim < maxSingedValue(bitSizeof(coordinate_T)/2));	
			}
			return grtr()->allocate(&_grtr,newLogical,bbox,recLen);
		} else {
			Box& newLogical = logical;
			newLogical.upperRight().y(ySplit);
			if (!less()) {
				splitInfo(newLogical,xDim.yDim,maxDim,splitX);
			    _less = new gsortTreeNode(xDim > yDim,
					maxDim < maxSingedValue(bitSizeof(coordinate_T)/2));	
			}
			return less()->allocate(&_less,newLogical,bbox,recLen);
		}
	}
	if (isFull && !cross()) {
		 *parentPtr = dynamic_cast<gsortTreeNode<gsortTmpltArgs>**> 
		 		(new gsortTreeNodeWithCross<gsortTmpltArgs> (*this));
		_less = 0;
		_grtr = 0;
		_shapes = 0;
		delete this;
		this = *parentPtr;	
	}
}

gsortTemplate
void*
gsortTree<gsortTmpltArgs>::allocate(Box bbox,int reclen)
{
	if (!top()) {
	    _top = new gsortTreeNode<gsortTmpltArgs>(false,false);
		_logical = _data = bbox;
	}
	if (top().isSplit() && !_logical.contains(bbox)) {
		growUpward(bbox);
	}
	return top.allocate(_logical,bbox,reclen);
}
