//***************************************************************************
//  test.cc  - gdb test routine
//                           -------------------
//  begin                : Thu Jun 3 2004
//  copyright            : (C) 2004 by Stan Benedict
//  email                : stanb@cybrquest.com
//***************************************************************************

#include <iostream>
#include <stdlib.h>
#include "types.h"
#include "random.h"
#include "timer.h"
#include "gdb.h"
#include "gshapeblock.h"

using namespace std;


void
randomBox(gdbBox& box)
{
	box.lowerLeft().x(Random::integer64());
	box.upperRight().x( Random::integer64());
	if (box.lowerLeft().x() > box.upperRight().x()) {
		int64 tmp = box.lowerLeft().x();
		box.lowerLeft().x(box.upperRight().x());
		box.upperRight().x(tmp);
	}
	box.lowerLeft().y(Random::integer64());
	box.upperRight().y( Random::integer64());
	if (box.lowerLeft().y() > box.upperRight().y()) {
		int64 tmp = box.lowerLeft().y();
		box.lowerLeft().y(box.upperRight().y());
		box.upperRight().y(tmp);
	}
}

typedef varShapeBlock<int64,gdbCoordinate,gdbShape> gsortShapeBlock;

int
main(int argc, char* argv[])
{
	if (argc != 2) {
		cerr << "Comand format: " << argv[0] << " numshapes" << endl;
	}
	int numShapes = atoi(argv[1]);
	gsortTree<int64,gdbCoordinate,gdbShape,gsortShapeBlock> gsort;
	Timer create;
	create.start();
	gdbBox bbox;
	int i;
	for (i = 0; i < numShapes; i++) {
		randomBox(bbox);
		new (gsort.allocate(bbox,gdbShape::reclen())) gdbShape(bbox);
	}
}
